Loading...
Searching...
No Matches
Ogre::SkeletonInstance Class Reference
Core » Scene

A SkeletonInstance is a single instance of a Skeleton used by a world object. More...

`#include <OgreSkeletonInstance.h>`

Inheritance diagram for Ogre::SkeletonInstance:
[legend]

## Public Member Functions

| SkeletonInstance (const SkeletonPtr &masterCopy)
| Constructor, don't call directly, this will be created automatically when you create an Entity based on a skeletally animated Mesh.
| ~SkeletonInstance ()
Animation * | _getAnimationImpl (const String &name, const LinkedSkeletonAnimationSource **linker=0) const override
| Internal accessor for animations (returns null if animation does not exist).
void | _initAnimationState (AnimationStateSet *animSet) override
| Initialise an animation set suitable for use with this skeleton.
void | _refreshAnimationState (AnimationStateSet *animSet) override
| Refresh an animation set suitable for use with this skeleton.
void | addLinkedSkeletonAnimationSource (const String &skelName, Real scale=1.0f) override
| Allows you to use the animations from another Skeleton object to animate this skeleton.
Animation * | createAnimation (const String &name, Real length) override
| Creates a new Animation object for animating this skeleton.
TagPoint * | createTagPointOnBone (Bone *bone, const Quaternion &offsetOrientation=Quaternion::IDENTITY, const Vector3 &offsetPosition=Vector3::ZERO)
| Creates a TagPoint ready to be attached to a bone.
void | freeTagPoint (TagPoint *tagPoint)
| Frees a TagPoint that already attached to a bone.
Animation * | getAnimation (const String &name, const LinkedSkeletonAnimationSource **linker=0) const override
| Returns the named Animation object.
Animation * | getAnimation (unsigned short index) const override
| Gets a single animation by index.
const String & | getGroup (void) const
| Gets the group which this resource is a member of.
ResourceHandle | getHandle (void) const
LinkedSkeletonAnimSourceIterator | getLinkedSkeletonAnimationSourceIterator (void) const override
const LinkedSkeletonAnimSourceList & | getLinkedSkeletonAnimationSources () const override
| Get the linked skeletons used as animation sources.
const String & | getName (void) const
| Gets resource name.
unsigned short | getNumAnimations (void) const override
| Gets the number of animations on this skeleton.
void | removeAllLinkedSkeletonAnimationSources (void) override
| Remove all links to other skeletons for the purposes of sharing animation.
void | removeAnimation (const String &name) override
| Removes an Animation from this skeleton.
Public Member Functions inherited from Ogre::Skeleton
| Skeleton (ResourceManager *creator, const String &name, ResourceHandle handle, const String &group, bool isManual=false, ManualResourceLoader *loader=0)
| Constructor, don't call directly, use SkeletonManager.
virtual | ~Skeleton ()
virtual void | _buildMapBoneByHandle (const Skeleton *source, BoneHandleMap &boneHandleMap) const
| Build the bone handle map to use with Skeleton::_mergeSkeletonAnimations.
virtual void | _buildMapBoneByName (const Skeleton *source, BoneHandleMap &boneHandleMap) const
| Build the bone handle map to use with Skeleton::_mergeSkeletonAnimations.
void | _getBoneMatrices (Affine3 *pMatrices)
| Populates the passed in array with the bone matrices based on the current position.
virtual void | _mergeSkeletonAnimations (const Skeleton *source, const BoneHandleMap &boneHandleMap, const StringVector &animations=StringVector())
| Merge animations from another Skeleton object into this skeleton.
virtual void | _notifyManualBonesDirty (void)
| Internal method for marking the manual bones as dirty.
virtual void | _notifyManualBoneStateChange (Bone *bone)
| Internal method for notifying that a bone is manual.
virtual void | _updateTransforms (void)
| Updates all the derived transforms in the skeleton.
virtual Bone * | createBone (const String &name)
| Creates a brand new Bone owned by this Skeleton.
virtual Bone * | createBone (const String &name, unsigned short handle)
| Creates a brand new Bone owned by this Skeleton.
virtual Bone * | createBone (unsigned short handle)
| Creates a brand new Bone owned by this Skeleton.
virtual Bone * | createBone (void)
| Creates a brand new Bone owned by this Skeleton.
Animation * | getAnimation (const String &name) const override
| Returns the named Animation object.
SkeletonAnimationBlendMode | getBlendMode () const
| Gets the animation blending mode which this skeleton will use.
Bone * | getBone (const String &name) const
| Gets a bone by it's name.
Bone * | getBone (unsigned short handle) const
| Gets a bone by it's handle.
virtual BoneIterator | getBoneIterator (void)
| Get an iterator over all the bones in the skeleton.
const BoneList & | getBones () const
| Get all the bones in the skeleton.
virtual bool | getManualBonesDirty (void) const
| Have manual bones been modified since the skeleton was last updated?
unsigned short | getNumBones (void) const
| Returns the number of bones in this skeleton.
virtual BoneIterator | getRootBoneIterator (void)
| Get an iterator over the root bones in the skeleton, ie those with no parents.
const BoneList & | getRootBones () const
| Get the root bones in the skeleton, ie those with no parents.
bool | hasAnimation (const String &name) const override
| Returns whether this object contains the named animation.
bool | hasBone (const String &name) const
| Returns whether this skeleton contains the named bone.
virtual bool | hasManualBones (void) const
| Are there any manually controlled bones?
virtual void | optimiseAllAnimations (bool preservingIdentityNodeTracks=false)
| Optimise all of this skeleton's animations.
void | reset (bool resetManualBones=false)
| Resets the position and orientation of all bones in this skeleton to their original binding position.
virtual void | setAnimationState (const AnimationStateSet &animSet)
| Changes the state of the skeleton to reflect the application of the passed in collection of animations.
void | setBindingPose (void)
| Sets the current position / orientation to be the 'binding pose' i.e.
void | setBlendMode (SkeletonAnimationBlendMode state)
| Sets the animation blending mode this skeleton will use.
Public Member Functions inherited from Ogre::Resource
| Resource (ResourceManager *creator, const String &name, ResourceHandle handle, const String &group, bool isManual=false, ManualResourceLoader *loader=0)
| Standard constructor.
virtual | ~Resource ()
| Virtual destructor.
virtual void | _dirtyState ()
| Manually mark the state of this resource as having been changed.
void | _fireLoadingComplete (bool unused=false)
| Firing of loading complete event.
void | _firePreparingComplete (bool unused=false)
| Firing of preparing complete event.
void | _fireUnloadingComplete (void)
| Firing of unloading complete event.
void | _notifyOrigin (const String &origin)
| Notify this resource of it's origin.
virtual void | addListener (Listener *lis)
| Register a listener on this resource.
virtual void | changeGroupOwnership (const String &newGroup)
| Change the resource group ownership of a Resource.
virtual void | escalateLoading ()
| Escalates the loading of a background loaded resource.
ResourceManager * | getCreator (void)
| Gets the manager which created this resource.
const String & | getGroup (void) const
| Gets the group which this resource is a member of.
ResourceHandle | getHandle (void) const
LoadingState | getLoadingState () const
| Returns the current loading state.
const String & | getName (void) const
| Gets resource name.
const String & | getOrigin (void) const
| Get the origin of this resource, e.g.
size_t | getSize (void) const
| Retrieves info about the size of the resource.
virtual size_t | getStateCount () const
| Returns the number of times this resource has changed state, which generally means the number of times it has been loaded.
bool | isBackgroundLoaded (void) const
| Returns whether this Resource has been earmarked for background loading.
bool | isLoaded (void) const
| Returns true if the Resource has been loaded, false otherwise.
bool | isLoading () const
| Returns whether the resource is currently in the process of background loading.
bool | isManuallyLoaded (void) const
| Is this resource manually loaded?
bool | isPrepared (void) const
| Returns true if the Resource has been prepared, false otherwise.
bool | isReloadable (void) const
| Returns true if the Resource is reloadable, false otherwise.
virtual void | load (bool backgroundThread=false)
| Loads the resource, if it is not already.
virtual void | prepare (bool backgroundThread=false)
| Prepares the resource for load, if it is not already.
virtual void | reload (LoadingFlags flags=LF_DEFAULT)
| Reloads the resource, if it is already loaded.
virtual void | removeListener (Listener *lis)
| Remove a listener on this resource.
void | setBackgroundLoaded (bool bl)
| Tells the resource whether it is background loaded or not.
virtual void | touch (void)
| 'Touches' the resource to indicate it has been used.
virtual void | unload (void)
| Unloads the resource; this is not permanent, the resource can be reloaded later if required.
Public Member Functions inherited from Ogre::StringInterface
| StringInterface ()
virtual | ~StringInterface ()
| Virtual destructor, see Effective C++.
void | copyParametersTo (StringInterface *dest) const
| Method for copying this object's parameters to another object.
ParamDictionary * | getParamDictionary (void)
| Retrieves the parameter dictionary for this class.
const ParamDictionary * | getParamDictionary (void) const
String | getParameter (const String &name) const
| Generic parameter retrieval method.
const ParameterList & | getParameters (void) const
| Retrieves a list of parameters valid for this object.
bool | setParameter (const String &name, const String &value)
| Generic parameter setting method.
void | setParameterList (const NameValuePairList &paramList)
| Generic multiple parameter setting method.
Public Member Functions inherited from Ogre::AnimationContainer
virtual | ~AnimationContainer ()

## Additional Inherited Members

Public Types inherited from Ogre::Skeleton
typedef std::vector< ushort > | BoneHandleMap
| Map to translate bone handle from one skeleton to another skeleton.
typedef VectorIterator< BoneList > | BoneIterator
typedef std::vector< Bone * > | BoneList
typedef ConstVectorIterator< LinkedSkeletonAnimSourceList > | LinkedSkeletonAnimSourceIterator
typedef std::vector< LinkedSkeletonAnimationSource > | LinkedSkeletonAnimSourceList
Public Types inherited from Ogre::Resource
enum | LoadingFlags { LF_DEFAULT = 0 , LF_INCLUDE_NON_RELOADABLE = 1 , LF_ONLY_UNREFERENCED = 2 , LF_ONLY_UNREFERENCED_INCLUDE_NON_RELOADABLE = 3 , LF_PRESERVE_STATE = 4 }
| Enum that allow to choose subset of unloaded/reloaded resources and to adjust reloading behavior. More...
enum | LoadingState { LOADSTATE_UNLOADED , LOADSTATE_LOADING , LOADSTATE_LOADED , LOADSTATE_UNLOADING , LOADSTATE_PREPARED , LOADSTATE_PREPARING }
| Enum identifying the loading state of the resource. More...
Public Types inherited from Ogre::AnimationContainer
typedef std::map< String, Animation * > | AnimationList
Static Public Member Functions inherited from Ogre::StringInterface
static void | cleanupDictionary ()
| Cleans up the static 'msDictionary' required to reset Ogre, otherwise the containers are left with invalid pointers, which will lead to a crash as soon as one of the ResourceManager implementers (e.g.

## Detailed Description

A SkeletonInstance is a single instance of a Skeleton used by a world object.

The difference between a Skeleton and a SkeletonInstance is that the Skeleton is the 'master' version much like Mesh is a 'master' version of Entity. Many SkeletonInstance objects can be based on a single Skeleton, and are copies of it when created. Any changes made to this are not reflected in the master copy. The exception is animations; these are shared on the Skeleton itself and may not be modified here.

## Constructor & Destructor Documentation

## SkeletonInstance()

Ogre::SkeletonInstance::SkeletonInstance | ( | const SkeletonPtr & | masterCopy | ) |

Constructor, don't call directly, this will be created automatically when you create an Entity based on a skeletally animated Mesh.

## ~SkeletonInstance()

Ogre::SkeletonInstance::~SkeletonInstance | ( |  | ) |

## Member Function Documentation

## getNumAnimations()

unsigned short Ogre::SkeletonInstance::getNumAnimations | ( | void |  | ) | const

override virtual

Gets the number of animations on this skeleton.

Reimplemented from Ogre::Skeleton.

## getAnimation() [1/2]

Animation * Ogre::SkeletonInstance::getAnimation | ( | unsigned short | index | ) | const

override virtual

Gets a single animation by index.

Reimplemented from Ogre::Skeleton.

## _getAnimationImpl()

Animation * Ogre::SkeletonInstance::_getAnimationImpl | ( | const String & | name,
|  | const LinkedSkeletonAnimationSource ** | linker = 0 ) const

override virtual

Internal accessor for animations (returns null if animation does not exist).

Reimplemented from Ogre::Skeleton.

## createAnimation()

Animation * Ogre::SkeletonInstance::createAnimation | ( | const String & | name,
|  | Real | length )

override virtual

Creates a new Animation object for animating this skeleton.

This method updates the reference skeleton, not just this instance!

Parameters

  name | The name of this animation
  length | The length of the animation in seconds

Reimplemented from Ogre::Skeleton.

## getAnimation() [2/2]

Animation * Ogre::SkeletonInstance::getAnimation | ( | const String & | name,
|  | const LinkedSkeletonAnimationSource ** | linker = 0 ) const

override virtual

Returns the named Animation object.

Reimplemented from Ogre::Skeleton.

## removeAnimation()

void Ogre::SkeletonInstance::removeAnimation | ( | const String & | name | ) |

override virtual

Removes an Animation from this skeleton.

This method updates the reference skeleton, not just this instance!

Reimplemented from Ogre::Skeleton.

## createTagPointOnBone()

TagPoint * Ogre::SkeletonInstance::createTagPointOnBone | ( | Bone * | bone,
|  | const Quaternion & | offsetOrientation = Quaternion::IDENTITY,
|  | const Vector3 & | offsetPosition = Vector3::ZERO )

Creates a TagPoint ready to be attached to a bone.

References Ogre::Quaternion::IDENTITY.

## freeTagPoint()

void Ogre::SkeletonInstance::freeTagPoint | ( | TagPoint * | tagPoint | ) |

Frees a TagPoint that already attached to a bone.

## addLinkedSkeletonAnimationSource()

void Ogre::SkeletonInstance::addLinkedSkeletonAnimationSource | ( | const String & | skelName,
|  | Real | scale = 1.0f )

override virtual

Allows you to use the animations from another Skeleton object to animate this skeleton.

If you have skeletons of identical structure (that means identically named bones with identical handles, and with the same hierarchy), but slightly different proportions or binding poses, you can re-use animations from one in the other. Because animations are actually stored as changes to bones from their bind positions, it's possible to use the same animation data for different skeletons, provided the skeletal structure matches and the 'deltas' stored in the keyframes apply equally well to the other skeletons bind position (so they must be roughly similar, but don't have to be identical). You can use the 'scale' option to adjust the translation and scale keyframes where there are large differences in size between the skeletons.

Note
  This method takes a skeleton name, rather than a more specific animation name, for two reasons; firstly it allows some validation of compatibility of skeletal structure, and secondly skeletons are the unit of loading. Linking a skeleton to another in this way means that the linkee will be prevented from being destroyed until the linker is destroyed.

You cannot set up cyclic relationships, e.g. SkeletonA uses SkeletonB's animations, and SkeletonB uses SkeletonA's animations. This is because it would set up a circular dependency which would prevent proper unloading - make one of the skeletons the 'master' in this case.

Parameters

  skelName | Name of the skeleton to link animations from. This skeleton will be loaded immediately if this skeleton is already loaded, otherwise it will be loaded when this skeleton is.
  scale | A scale factor to apply to translation and scaling elements of the keyframes in the other skeleton when applying the animations to this one. Compensates for skeleton size differences.

Reimplemented from Ogre::Skeleton.

## removeAllLinkedSkeletonAnimationSources()

void Ogre::SkeletonInstance::removeAllLinkedSkeletonAnimationSources | ( | void |  | ) |

override virtual

Remove all links to other skeletons for the purposes of sharing animation.

Reimplemented from Ogre::Skeleton.

## getLinkedSkeletonAnimationSources()

const LinkedSkeletonAnimSourceList & Ogre::SkeletonInstance::getLinkedSkeletonAnimationSources | ( |  | ) | const

override virtual

Get the linked skeletons used as animation sources.

Reimplemented from Ogre::Skeleton.

## getLinkedSkeletonAnimationSourceIterator()

LinkedSkeletonAnimSourceIterator Ogre::SkeletonInstance::getLinkedSkeletonAnimationSourceIterator | ( | void |  | ) | const

override virtual

Deprecated
  use getLinkedSkeletonAnimationSources

Reimplemented from Ogre::Skeleton.

## _initAnimationState()

void Ogre::SkeletonInstance::_initAnimationState | ( | AnimationStateSet * | animSet | ) |

override virtual

Initialise an animation set suitable for use with this skeleton.

Only recommended for use inside the engine, not by applications.

Reimplemented from Ogre::Skeleton.

## _refreshAnimationState()

void Ogre::SkeletonInstance::_refreshAnimationState | ( | AnimationStateSet * | animSet | ) |

override virtual

Refresh an animation set suitable for use with this skeleton.

Only recommended for use inside the engine, not by applications.

Reimplemented from Ogre::Skeleton.

## getName()

const String & Ogre::SkeletonInstance::getName | ( | void |  | ) | const

Gets resource name.

## getHandle()

ResourceHandle Ogre::SkeletonInstance::getHandle | ( | void |  | ) | const

## getGroup()

const String & Ogre::SkeletonInstance::getGroup | ( | void |  | ) | const

Gets the group which this resource is a member of.

The documentation for this class was generated from the following file:

- OgreSkeletonInstance.h